/** 
 * SMARTS cognitive science programming project
 * May 2000
 * Mike Gasser (gasser@indiana.edu)
 */

import java.io.*;

abstract class Effector {

  protected int nActions;
  
  protected Critter critter;
    
  protected UI ui;
  
  Effector(UI ui, Critter critter, int nActions) {
    this.ui = ui;
    this.critter = critter;
    this.nActions = nActions;
  } // constructor Effector

  // Access methods.
  
  public abstract String getActionName(int index);
  
  public int getNActions() {
      return nActions;
  } // method getNActions
  
  protected int[] index2Vector(int index) {
      int[] vec = new int[nActions];
      int i;
      
      for (i = 0; i < nActions; i++) {
          if (i == index)
	      vec[i] = 1;
	  else
	      vec[i] = 0;
      }
      return vec;
  } // method index2Vector(int)
  
  public abstract void attempt(int index);
   
} // class Effector
