import java.awt.*;
import java.awt.event.*;

public class MakeEnv extends Dialog
       implements ActionListener, ItemListener {

  private static final String
    OK = "OK",
    CANCEL = "Cancel";
    
  private static final int
    TF_WIDTH = 6,
    WIDTH = 300,
    HEIGHT = 300;

  private Button
    okButton, cancelButton;
    
  private TextField[]
    textFields;

  private ScrollPane
    sp = new ScrollPane(ScrollPane.SCROLLBARS_ALWAYS);
  private Panel
    panel = new Panel();
    
  private String name;
//  private TextField tf;
  private Species species;
  private UI ui;
  
  private int
    width, height;

  MakeEnv(UI ui, String title) {
    super(ui, title, true);
    this.ui = ui;
    width = WIDTH;
    height = HEIGHT;
    
    Panel paramPanel = new Panel();
    paramPanel.setLayout(new GridLayout(3, 1));
    sp.add(paramPanel);

    paramPanel.add(makeParamPanel("Number of plants", 0));
    paramPanel.add(makeParamPanel("Number of rocks", 0));
//    paramPanel.add(makeChoiceParamPanel("Plant edibility",
//					PLANT_EDIBILITY));

    Panel bPanel = new Panel();
    bPanel.setLayout(new FlowLayout());
    okButton = new Button(OK);
    okButton.addActionListener(this);
    bPanel.add(okButton);
    cancelButton = new Button(CANCEL);
    cancelButton.addActionListener(this);
    bPanel.add(cancelButton);

    setLayout(new BorderLayout());
    add("Center", sp);
    add("South", bPanel);
    
    pack();
    setVisible(true);
  } // constructor MakeEnv(UI, String)
  
  private Panel makeParamPanel(Param param) {
      Panel p = new Panel();
      Label l = new Label(param.getLabel());
      p.add(l);
      if (param.hasChoice()) {
          Choice c = new Choice();
          String[] choices = param.getChoices();
	  int i;
	  for (i = 0; i < choices.length; i++)
	      c.addItem(choices[i]);
	  c.addItemListener(this);
	  p.add(c);
      } else {
	  TextField tf = new TextField(String.valueOf(param.get()), TF_WIDTH);
	  tf.addActionListener(this);
	  p.add(tf);
      }

      return p;
  } // makeParamPanel(Param)
  
  private Panel makeParamPanel(String label, int val) {
      Label l = new Label(label);
      TextField tf = new TextField(String.valueOf(val), TF_WIDTH);
      Panel p = new Panel();
      p.add(l);
      p.add(tf);
      tf.addActionListener(this);
      return p;
  } // makeParamPanel(String, int)
  
  private Panel makeChoiceParamPanel(String label, String[] choices) {
      Label l = new Label(label);
      Choice c = new Choice();
      Panel p = new Panel();
      
      for (int i = 0; i < choices.length; i++)
	  c.addItem(choices[i]);
      p.add(l);
      p.add(c);
      c.addItemListener(this);
      return p;
  } // makeChoiceParamPanel(String, String[])

  /**
  * Set the size of the canvas and the frame.
  */
  public Dimension getMinimumSize() {
    return new Dimension (width, height);
  } // getMinimumSize()

  public Dimension getPreferredSize() {
    return getMinimumSize();
  } // getPreferredSize()
  
  public void actionPerformed(ActionEvent event) {
      Object source = event.getSource();
      int c;
      
      if (source.equals(okButton)) {
//	  int n = Integer.parseInt(tf.getText());
//	  if (n > 0) {
//	      dispose();
//	  }
//	  else
//	      ui.write("You must specify an integer!");
	  dispose();

      } else if (source.equals(cancelButton))
	  dispose();
      else
	  ui.write("Hunh?");

  } // actionPerformed(ActionEvent)
  
  public void itemStateChanged(ItemEvent event) {
      ItemSelectable i = event.getItemSelectable();
//    int i = choice.getSelectedIndex();
  } // itemStateChanged(ItemEvent)

} // class MakeEnv
