/** 
 * SALSA 1.1
 * June 2000
 * Mike Gasser (gasser@indiana.edu)
 **/

import java.awt.*;
import java.awt.event.*;

class ParamFrame extends Frame
  implements WindowListener, ActionListener {  

  private final String
    OK = "OK",
    CANCEL = "Cancel";
  
  private UI parent;
  
  private TextField
//    sizeField,
    pauseField,
    TSField,
    verbField;
    
  private Button
    OKButton,
    cancelButton;

  ParamFrame (UI parent) {
    this.parent = parent;
    
    Font fb = new Font("Helvetica", Font.BOLD, 10);

    TSField = new TextField(String.valueOf(UI.nRunTimeSteps), 5);
    TSField.addActionListener (this);

    verbField = new TextField(String.valueOf(UI.verbosity), 5);
    verbField.addActionListener(this);
    
    pauseField = new TextField(String.valueOf(UI.stepPause), 5);
    pauseField.addActionListener(this);

    /*
    sizeField = new TextField(String.valueOf(UI.cellSize), 5);
    sizeField.addActionListener(this);
    */

    Panel buttons = new Panel();
    buttons.setLayout (new FlowLayout());
    OKButton = new Button (OK);
    OKButton.addActionListener (this);
    cancelButton = new Button (CANCEL);
    cancelButton.addActionListener (this);
    buttons.add (OKButton);
    buttons.add (cancelButton);
    
    Panel north = new Panel();
    north.setLayout(new GridLayout(4, 1));
//    north.setLayout (new BorderLayout());

    Panel TSPanel = new Panel();
    Label TSLabel = new Label("# time steps per run", Label.LEFT);
    TSLabel.setFont (fb);
    TSPanel.add ("West", TSLabel);
    TSPanel.add ("East", TSField);

    Panel verbPanel = new Panel();
    Label verbLabel = new Label("Verbosity level", Label.LEFT);
    verbLabel.setFont (fb);
    verbPanel.add ("West", verbLabel);
    verbPanel.add ("East", verbField);

    Panel pausePanel = new Panel();
    Label pauseLabel = new Label("Pause between steps (ms)", Label.LEFT);
    pauseLabel.setFont (fb);
    pausePanel.add ("West", pauseLabel);
    pausePanel.add ("East", pauseField);

    /*
    Panel sizePanel = new Panel();
    Label sizeLabel = new Label("World display size", Label.LEFT);
    sizeLabel.setFont (fb);
    sizePanel.add ("West", sizeLabel);
    sizePanel.add ("East", sizeField);
    */

    north.add(TSPanel);
    north.add(verbPanel);
    north.add(pausePanel);
//    north.add(sizePanel);

    add ("North", north);
    add ("South", buttons);

    setTitle ("Set display parameters");

    pack();
    setVisible (true);
  }

  public void windowClosed (WindowEvent event) {
  }

  public void windowDeiconified (WindowEvent event) {
  }

  public void windowIconified (WindowEvent event) {
  }

  public void windowActivated (WindowEvent event) {
  }

  public void windowDeactivated (WindowEvent event) {
  }

  public void windowOpened (WindowEvent event) {
  }

  public void windowClosing (WindowEvent event) {
    dispose();
  }

  public void actionPerformed (ActionEvent event) {
    Object source = event.getSource();
    String text;

    if (source.equals (OKButton)) {
	UI.nRunTimeSteps = Integer.parseInt(TSField.getText());
	UI.verbosity = Integer.parseInt(verbField.getText());
	if (UI.verbosity < 0)
	    UI.verbosity = 0;
	UI.stepPause = Integer.parseInt(pauseField.getText());
//	UI.cellSize = Integer.parseInt(sizeField.getText());
	dispose();
	
    } else if (source.equals (cancelButton)) {
	dispose();

    }
    
	/*
    } else if (source instanceof TextField) {
	if (source.equals (TSField)) {
	    parent.write("N of time steps changed.");
	    UI.nRunTimeSteps = Integer.parseInt(TSField.getText());
	}
	
	else if (source.equals(verbField)) {
	    parent.write("Verbosity changed.");
	    UI.verbosity = Integer.parseInt(verbField.getText());
	}
    }
    */
  }

  public Dimension getMinimumSize() {
    return new Dimension (300, 200);
  }

  public Dimension getPreferredSize() {
    return getMinimumSize();
  }
}

