/** 
 * SALSA 1.1
 * June 2000
 * Mike Gasser (gasser@indiana.edu)
 */

import java.io.*;
import java.awt.Color;

/** A Thing occupying one or more Cells which
* represents an obstacle to Critters.
*/

public class Rock extends Thing {

  public final static Color
    COLOR = Cell.MEDIUM_BLUE,
    COLOR1 = Color.blue;
    
  Rock (World world, UI ui) {
    this(world, ui, COLOR);
// (Math.random() < .5 ? COLOR : COLOR2));
  } // constructor Rock
  
  /**
  * This constructor forces a particular color.
  */
  Rock(World world, UI ui, Color color) {
    super (world, ui, color);
    typeString = "Rock";
    name = typeString + index;
  } // constructor Rock
  
  /**
  * Writes the state of the Rock to a file.
  */
  public void write(PrintWriter out) {
    int cellIndex;
    Cell cell;

    out.print("rock  ");
    for (cellIndex = 0; cellIndex < getNCells(); cellIndex++) {
	cell = getCell (cellIndex);
	out.println (cell.getColumn() + " " + cell.getRow());
    }
  } // method write(PrintWriter)
  
  public void describe() {
    ui.write ("  Rock " + index + ":");
    ui.write ("    " + cells.size() + " cells");
  }  // method describe()

  public boolean isEdible() {
      return false;
  } // method isEdible()
  
  public void getHit() {
  } // method getHit()

} // class Rock

