/** 
 * SALSA
 * June 1999
 * Mike Gasser (gasser@indiana.edu)
 */

import java.awt.*;
import java.awt.event.*;

/** Button that can be clicked, generating an ActionEvent
* that is heard by its parent, and also respond to other
* MouseEvents, in particular enter and exit (for giving
* help about the Button's function).
*/

class SalsaButton extends Button {  

  private UI ui;
  
  private Container parent;
  
  public String
    helpText;
  
  SalsaButton (Container parent, UI ui, String label, String helpText) {
    super (label);
    this.parent = parent;
    this.ui = ui;
    this.helpText = helpText;
    addActionListener ((ActionListener) parent);
    addMouseListener ((MouseListener) parent);
  } // constructor SalsaButton

} // class SalsaButton

