/** 
 * SMARTS cognitive science programming project
 * May 2000
 * Mike Gasser (gasser@indiana.edu)
 */

import java.io.*;

public class Turner extends Effector {
    
  public static final int
    TURN1 = 0,
    TURN5 = 1,
    TURN2 = 2,
    TURN4 = 3,
    TURN3 = 4;
    
  public static final String[]
    ACTIONS = {"Turn R1", "Turn L1", "Turn R2", "Turn L2", "Turn 3"};
    
  Turner (UI ui, Critter critter, int nActions) {
    super(ui, critter, nActions);
  } // constructor Turner

  // Access methods.
  
  public String getActionName (int index)  {
      return ACTIONS[index];
  } // method getActionName(int)

  public void attempt(int index) {
      ui.write("Turner attempting " + getActionName(index), 1);
      switch (index) {
	case TURN1:
	  critter.turn(1);
	  break;
	case TURN2:
	  critter.turn(2);
	  break;
	case TURN3:
	  critter.turn(3);
	  break;
	case TURN4:
	  critter.turn(4);
	  break;
	case TURN5:
	  critter.turn(5);
	  break;
	default:
	  ui.write("Turner doesn't know how to do " + index);
      }
  } // method attempt(int)

} // class Turner
